/*		

	talkie : un objet nul.

*/

// -------------------------------------------------------------------------------------------------------------

#include "ext.h"							
#include "ext_obex.h"
	
// -------------------------------------------------------------------------------------------------------------

typedef struct _talkie {
	t_object		ob ;
	t_atom			value[2] ;
	t_object		*dad ;
	} t_talkie ;
	
// -------------------------------------------------------------------------------------------------------------	
	
void	*talkie_new (t_symbol *s, long argc, t_atom *argv) ;
void	talkie_free (t_talkie *x) ;
void	talkie_assist (t_talkie *x, void *b, long m, long a, char *s) ;

void	talkie_int (t_talkie *x, long n) ;
void	talkie_set_dad (t_talkie *x, t_object *ptr) ;
void	talkie_set_name (t_talkie *x, long n) ;

t_atom	*talkie_get	(t_talkie *x) ;

// -------------------------------------------------------------------------------------------------------------

static t_class *talkie_class ;

int main (void)
	{	
		t_class *c = NULL ;
		
		c = class_new ("talkie", (method)talkie_new, (method)talkie_free, (long)sizeof(t_talkie), 0L, A_GIMME, 0) ;
		
		class_addmethod (c, (method)talkie_assist,		"assist", A_CANT, 0) ;
		class_addmethod (c, (method)talkie_int,			"int", A_LONG, 0) ;
		class_addmethod (c, (method)talkie_get,			"get", 0) ;
		class_addmethod (c, (method)talkie_set_dad,		"set_dad", A_CANT, 0) ;
		class_addmethod (c, (method)talkie_set_name,	"set_name", A_LONG, 0) ;
		
		class_register (CLASS_BOX, c) ; 
		
		talkie_class = c ;
		
		return 0 ;
	}

void *talkie_new (t_symbol *s, long argc, t_atom *argv)
	{
		t_talkie *x = NULL;
		
		if (x = (t_talkie *)object_alloc (talkie_class)) 
			{		
				x->dad	= NULL ;
				atom_setlong (x->value, 0) ;
				atom_setlong (x->value + 1, -1) ;
			}
				
		return x ;
	}

void talkie_free (t_talkie *x)
	{ 
		;
	}

void talkie_assist (t_talkie *x, void *b, long m, long a, char *s)
	{
		if (m == ASSIST_INLET) 
			{ 
				sprintf (s, "(int)") ;
			} 
	}
	
// -------------------------------------------------------------------------------------------------------------

void talkie_int (t_talkie *x, long n)
	{
		atom_setlong (x->value, n) ;
		
		if (x->dad)
			{
				object_method (x->dad, gensym ("feedback"), x->value) ;
			}
	}
	
void talkie_set_dad (t_talkie *x, t_object *ptr)
	{
		x->dad = ptr ;
	}

void talkie_set_name (t_talkie *x, long n) 
	{
		atom_setlong (x->value + 1, n) ;
	}

t_atom *talkie_get (t_talkie *x)
	{
		return x->value ;
	}

// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x