/*		
	Next step : right to left !!!
*/

// -------------------------------------------------------------------------------------------------------------

#include "ext.h"							
#include "ext_obex.h"
#include "jpatcher_api.h"
	
// -------------------------------------------------------------------------------------------------------------

typedef struct _walkie {
	t_object	ob ;
	t_object	*me ;
	t_object	*mypatcher ;			
	t_object	*mypatcherview ;
	t_linklist	*talkies ;
	long		dirty ;
	void		*m_out ;
	} t_walkie ;
	
// -------------------------------------------------------------------------------------------------------------	
	
void *walkie_new		(t_symbol *s, long argc, t_atom *argv) ;
void walkie_attach		(t_walkie *x) ;
void walkie_free		(t_walkie *x) ;
void walkie_assist		(t_walkie *x, void *b, long m, long a, char *s) ;

void walkie_notify		(t_walkie *x, t_symbol *s, t_symbol *msg, void *sender, void *data) ;
void walkie_bang		(t_walkie *x) ;
void walkie_int			(t_walkie *x, long n) ;

void walkie_feedback	(t_walkie *x, t_atom *ptr) ;

void pickup_talkie		(t_walkie *x) ;
long find_talkie		(t_walkie *x, t_object *ptr_b) ;

// -------------------------------------------------------------------------------------------------------------

static t_class *walkie_class ;

int main (void)
	{	
		t_class *c = NULL ;
		
		c = class_new ("walkie", (method)walkie_new, (method)walkie_free, (long)sizeof(t_walkie), 0L, A_GIMME, 0) ;
		
		class_addmethod (c, (method)walkie_assist,		"assist", A_CANT, 0) ;
		class_addmethod (c, (method)walkie_notify,		"notify", A_CANT, 0) ; 
		class_addmethod (c, (method)walkie_int,			"int", A_LONG, 0) ;
		class_addmethod (c, (method)walkie_feedback,	"feedback", A_CANT, 0) ;
		class_addmethod (c, (method)walkie_bang,		"bang", 0) ;
		
		class_register (CLASS_BOX, c) ; 
		
		walkie_class = c ;
		
		return MAX_ERR_NONE ;
	}

void *walkie_new (t_symbol *s, long argc, t_atom *argv)
	{
		t_walkie *x = NULL;
		
		if (x = (t_walkie *)object_alloc (walkie_class)) 
			{	
				
				
				x->dirty		= 1 ;
				x->me			= NULL ;
			
				x->talkies		= linklist_new () ;
				linklist_flags	(x->talkies, OBJ_FLAG_REF) ;
				
				object_obex_lookup (x, gensym ("#P"), &x->mypatcher) ;
				
				defer_low (x, (method)walkie_attach, NULL, 0, NULL) ;
				
				defer_low (x, (method)pickup_talkie, NULL, 0, NULL) ;
				
				x->m_out = intout ((t_object *)x) ;
			}
				
		return x ;
	}

void walkie_attach (t_walkie *x)
	{	
		x->mypatcherview = object_attr_getobj (x->mypatcher, gensym ("firstview")) ;
		object_attach_byptr_register (x, x->mypatcherview, CLASS_NOBOX) ;
	}
	
void walkie_free (t_walkie *x)
	{ 
		t_object *ptr_p = NULL ;
		t_object *ptr_v = NULL ;

		object_obex_lookup (x, gensym ("#P"), &ptr_p) ;
		
		if (ptr_p) 
			{
				ptr_v = jpatcher_get_firstview (ptr_p) ;
				object_detach_byptr (x, ptr_v) ;
			}
		
		if (x->talkies)
			{
				object_free (x->talkies) ;
			}
	}

void walkie_assist (t_walkie *x, void *b, long m, long a, char *s)
	{
		if (m == ASSIST_INLET) 
			{ 
				sprintf (s, "(int)") ;
			} 
		else 
			{	
				sprintf (s, "(int)") ;	
			}
	}

// -------------------------------------------------------------------------------------------------------------

void walkie_notify (t_walkie *x, t_symbol *s, t_symbol *msg, void *sender, void *data)
	{
		if (msg == gensym ("attr_modified") && sender == x->mypatcherview) 
			{ 			
				t_symbol *attr_name ;
				
				attr_name = (t_symbol *)object_method (data, gensym ("getname")) ;
				
				if (attr_name == gensym ("dirty")) 
					{
						x->dirty = 1 ;
					}
					
				if (attr_name == gensym ("locked")) 
					{
						if (patcherview_get_locked (x->mypatcherview) && x->dirty) 
							{
								pickup_talkie (x) ;
							}	
					}
				
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void walkie_int (t_walkie *x, long n)
	{
		outlet_int (x->m_out, n) ;
	}

void walkie_bang (t_walkie *x) 
	{
		if (x->talkies)
			{
				long		k = 0 ;
				t_object	*ptr1 = NULL ;
				t_object	*ptr2 = NULL ;
				
				if (ptr1 = linklist_getindex (x->talkies, 0))   
					{
						while (ptr1) 
							{
								t_atom *aptr ;
								
								aptr = (t_atom *)object_method (ptr1, gensym ("get")) ;
								
								k += atom_getlong (aptr) ;
								
								post ("walkie receive : %ld", atom_getlong (aptr)) ;
								
								linklist_next (x->talkies, (void *)ptr1, (void *)&ptr2) ;
								ptr1 = ptr2 ;	
							}
						
						post ("and the sum is : %ld", k) ;
					}
			}
	}
	
void walkie_feedback (t_walkie *x, t_atom *ptr) 
	{
		long v = atom_getlong (ptr) ;
		long s = atom_getlong (ptr + 1) ;
		
		post ("walkie receive : %ld from talkie %ld", v, s) ;
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void pickup_talkie (t_walkie *x)
	{
		long		k = 0 ;
		t_object	*ptr_p = NULL ;
		t_object	*ptr1 = NULL ;
		t_object	*ptr2 = NULL ;
		
		if (x->talkies)
			{
				linklist_clear (x->talkies) ;
				
				if (!(object_obex_lookup (x, gensym ("#P"), &ptr_p)))
					{
						long	 result = 0 ;
						t_object *ptr_b = NULL ;
						
						object_obex_lookup (x, gensym ("#B"), &ptr_b) ;

						x->me = jbox_get_object (ptr_b) ;
						
						object_method (ptr_p, gensym ("iterate"), (method)find_talkie, x, PI_WANTBOX | PI_DEEP, &result) ;
					}
				
				if (ptr1 = linklist_getindex (x->talkies, 0))   
					{
						while (ptr1) 
							{
								object_method (ptr1, gensym ("set_dad"), x->me) ;
								object_method (ptr1, gensym ("set_name"), k) ;
								k++ ;
								
								linklist_next (x->talkies, (void *)ptr1, (void *)&ptr2) ;
								ptr1 = ptr2 ;	
							}
					}
			}
			
		x->dirty = 0 ;	
	}	
	
long find_talkie (t_walkie *x, t_object *ptr_b)
	{
		t_symbol *sym_b = jpatcher_get_maxclass (ptr_b) ; 
		
		if (sym_b == gensym ("talkie"))
			{
				t_object *ptr_o	= NULL ;
				
				ptr_o = jbox_get_object (ptr_b) ;
				
				linklist_append (x->talkies, ptr_o) ;
			}
			
		return 0 ;
	}
	
// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x